;; water pump control
;;
;; Copyright 2013 - By Michael Kohn
;; http://www.mikekohn.net/
;; mike to mikekohn.net
;;
;; Control a water pump that pumps water into a statue.  When the water
;; gets too high, the pump stops.  When it's too low it starts again.

.include "msp430x2xx.inc"

RAM equ 0x0200

;  r4 = function parameter
;  r5 =
;  r6 = byte coming in from UART
;  r7 =
;  r8 =
;  r9 =
; r10 =
; r11 =
; r12 =
; r13 =
; r14 =
; r15 =

.org 0xf800
start:
  ;; Turn off watchdog
  mov.w #(WDTPW|WDTHOLD), &WDTCTL

  ;; Please don't interrupt me
  dint

  ;; Set up stack pointer
  mov.w #0x0280, SP

.if 0
  ;; Set MCLK to 16 MHz with DCO 
  mov.b #DCO_4, &DCOCTL
  mov.b #RSEL_15, &BCSCTL1
  mov.b #0, &BCSCTL2
.endif

.if 0
  ;; Set MCLK to 16 MHz external crystal
  bic.w #OSCOFF, SR
  bis.b #XTS, &BCSCTL1
  mov.b #LFXT1S_3, &BCSCTL3
  ;mov.b #LFXT1S_3|XCAP_1, &BCSCTL3
test_osc:
  bic.b #OFIFG, &IFG1
  mov.w #0x00ff, r15
dec_again:
  dec r15
  jnz dec_again
  bit.b #(OFIFG), &IFG1
  jnz test_osc
  mov.b #(SELM_3|SELS), &BCSCTL2
.endif

  ;; Set up output pins
  ;; P1.1 = RX
  ;; P1.2 = TX
  mov.b #0x20, &P1DIR
  mov.b #0x18, &P1OUT
  mov.b #0x00, &P1REN

  ;; Okay, I can be interrupted now
  eint

main:

water_not_at_bottom:
  bit.b #0x08, &P1IN
  jz water_not_at_bottom
  bis.b #0x20, &P1OUT

water_not_at_top:
  bit.b #0x10, &P1IN
  jnz water_not_at_top
  bic.b #0x20, &P1OUT

  jmp main

.if 0
timer_interrupt:
  reti
.endif

  org 0xffe8
vectors:
  dw 0
  dw 0
  dw 0
  dw 0
  dw 0
  dw 0 ;timer_interrupt       ; Timer_A2 TACCR0, CCIFG
  dw 0
  dw 0
  dw 0
  dw 0
  dw 0
  dw start                 ; Reset



